%global eclipse_dropin   %{_datadir}/eclipse/dropins

%global tag DTP_1_12_0_Branch

%global qualifier v201406061400

Name:      eclipse-dtp
Version:   1.12.0
Release:   3%{?dist}
Summary:   Eclipse Data Tools Platform
Group:     System Environment/Libraries
License:   EPL
URL:       http://www.eclipse.org/datatools/

# get-dtp.sh will download all these tarballs
Source0:   http://git.eclipse.org/c/datatools/org.eclipse.datatools.build.git/snapshot/org.eclipse.datatools.build-%{tag}.tar.bz2
Source1:   http://git.eclipse.org/c/datatools/org.eclipse.datatools.connectivity.git/snapshot/org.eclipse.datatools.connectivity-%{tag}.tar.bz2
Source2:   http://git.eclipse.org/c/datatools/org.eclipse.datatools.doc.git/snapshot/org.eclipse.datatools.doc-%{tag}.tar.bz2
Source3:   http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.general.git/snapshot/org.eclipse.datatools.enablement.general-%{tag}.tar.bz2
Source4:   http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.hsqldb.git/snapshot/org.eclipse.datatools.enablement.hsqldb-%{tag}.tar.bz2
Source5:   http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.ibm.git/snapshot/org.eclipse.datatools.enablement.ibm-%{tag}.tar.bz2
Source6:   http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.ingres.git/snapshot/org.eclipse.datatools.enablement.ingres-%{tag}.tar.bz2
Source7:   http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.msft.git/snapshot/org.eclipse.datatools.enablement.msft-%{tag}.tar.bz2
Source8:   http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.mysql.git/snapshot/org.eclipse.datatools.enablement.mysql-%{tag}.tar.bz2
Source9:   http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.oda.git/snapshot/org.eclipse.datatools.enablement.oda-%{tag}.tar.bz2
Source10:  http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.oracle.git/snapshot/org.eclipse.datatools.enablement.oracle-%{tag}.tar.bz2
Source11:  http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.postgresql.git/snapshot/org.eclipse.datatools.enablement.postgresql-%{tag}.tar.bz2
Source12:  http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.sap.git/snapshot/org.eclipse.datatools.enablement.sap-%{tag}.tar.bz2
Source13:  http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.sqlite.git/snapshot/org.eclipse.datatools.enablement.sqlite-%{tag}.tar.bz2
Source14:  http://git.eclipse.org/c/datatools/org.eclipse.datatools.enablement.sybase.git/snapshot/org.eclipse.datatools.enablement.sybase-%{tag}.tar.bz2
Source16:  http://git.eclipse.org/c/datatools/org.eclipse.datatools.modelbase.git/snapshot/org.eclipse.datatools.modelbase-%{tag}.tar.bz2
Source17:  http://git.eclipse.org/c/datatools/org.eclipse.datatools.sqltools.git/snapshot/org.eclipse.datatools.sqltools-%{tag}.tar.bz2
Source18:  get-dtp.sh

# Build with Java 7 SQL interfaces
Patch0:    %{name}-java7.patch
Patch2:    %{name}-java7-ibm.patch

# remove duplicate plugin from sqltools features (it's actually built in the
# connectivity feature)
Patch1:    %{name}-remove-duplicate-plugin.patch

Patch6:    %{name}-enable-newer-javax.wsdl.patch
Patch7:    %{name}-remove-javaxxml.patch 

# port to a newer version of lucene
Patch8:    %{name}-lucene4-port.patch 

BuildArch:        noarch

BuildRequires:    java-devel >= 1:1.7.0
BuildRequires:    eclipse-pde >= 1:4.2.0-0.4
BuildRequires:    eclipse-emf-runtime
BuildRequires:    eclipse-gef
BuildRequires:    wsdl4j >= 1.5.2-6.6
BuildRequires:    xerces-j2 >= 2.7.1-10.3
BuildRequires:    xml-commons-resolver >= 1.1-2.15
BuildRequires:    xalan-j2 >= 2.7.0-7.5
BuildRequires:    xml-commons-apis >= 1.3.04-1.4
BuildRequires:    lpg-java-compat = 1.1.0
BuildRequires:    lucene
BuildRequires:    lucene-analysis
BuildRequires:    lucene-queryparser

Requires:         eclipse-platform >= 1:4.2.0-0.4
Requires:         eclipse-emf
Requires:         eclipse-gef
Requires:         wsdl4j >= 1.5.2-6.6
Requires:         xerces-j2 >= 2.7.1-10.3
Requires:         xml-commons-resolver >= 1.1-2.15
Requires:         xalan-j2 >= 2.7.0-7.5
Requires:         xml-commons-apis >= 1.3.04-1.4
Requires:         lpg-java-compat = 1.1.0
Requires:         lucene
Requires:         lucene-analysis
Requires:         lucene-queryparser

%description
The Eclipse Data Tools Platform provides extensible frameworks and exemplary 
tools, enabling a diverse set of plug-in offerings specific to particular 
data-centric technologies and supported by the DTP ecosystem.

%prep
%setup -q -c dtp-%{version} -a 1 -a 2 -a 3 -a 4 -a 5 -a 6 -a 7 -a 8 -a 9 -a 10 -a 11 -a 12 -a 13 -a 14 -a 16 -a 17

# apply patches
pushd org.eclipse.datatools.connectivity-%{tag}
%patch0
popd
pushd org.eclipse.datatools.build-%{tag}
%patch1 -p1
%patch7 -p2
popd
pushd org.eclipse.datatools.enablement.ibm-%{tag}
%patch2
popd
pushd org.eclipse.datatools.enablement.oda-%{tag}
%patch6 -p1
popd
pushd org.eclipse.datatools.sqltools-%{tag}/
%patch8 -b .orig
popd

pushd org.eclipse.datatools.build-%{tag}/features
# Use any xerces version
sed -i -e "s|2.9.0.qualifier|0.0.0|g" \
  org.eclipse.datatools.enablement.oda.feature/feature.xml
popd


# This jar needs to be unzipped so that it can be rebuilt
# It doesn't contain any binary stuff, just stored as a jar in source repo :-/
unzip -q -o -d org.eclipse.datatools.doc.user \
  org.eclipse.datatools.doc-%{tag}/packaged_jars/org.eclipse.datatools.doc.user_1.7.0.20090521092446.jar


pushd org.eclipse.datatools.doc-%{tag}/packaged_jars
rm -rf *.jar
popd


# make sure upstream hasn't snuck in any jars we don't know about
JARS=""
for j in `find -name "*.jar"`; do
  if [ ! -L $j ]; then
    JARS="$JARS $j"
  fi
done
if [ ! -z "$JARS" ]; then
   echo "These jars should be deleted and symlinked to system jars: $JARS"
   # There are some test JARs that can remain
   #exit 1
fi

mkdir orbitDeps
pushd orbitDeps
ln -s %{_javadir}/lpgjavaruntime.jar .
ln -s %{_javadir}/lucene/lucene-core.jar .
ln -s %{_javadir}/lucene/lucene-queryparser.jar .
ln -s %{_javadir}/lucene/lucene-analyzers-common.jar .
ln -s %{_javadir}/xerces-j2.jar org.apache.xerces_2.9.0.jar
ln -s %{_javadir}/xalan-j2-serializer.jar org.apache.xml.serializer_2.7.1.jar
ln -s %{_javadir}/xml-commons-resolver.jar org.apache.xml.resolver_1.2.0.jar
ln -s %{_javadir}/wsdl4j.jar javax.wsdl_1.5.1.jar
popd

%build
OPTIONS="-DjavacTarget=1.7 -DjavacSource=1.7 -DforceContextQualifier=%{qualifier}"

# build all features except for SDK features TODO: build everything
eclipse-pdebuild -f org.eclipse.datatools.modelbase.feature \
  -d "emf-runtime gef-core" -o `pwd`/orbitDeps -a "$OPTIONS"
eclipse-pdebuild -f org.eclipse.datatools.connectivity.feature \
  -d "emf-runtime gef-core" -o `pwd`/orbitDeps -a "$OPTIONS"
eclipse-pdebuild -f org.eclipse.datatools.sqldevtools.feature \
  -d "emf-runtime gef-core" -o `pwd`/orbitDeps -a "$OPTIONS"
eclipse-pdebuild -f org.eclipse.datatools.enablement.feature \
  -d "emf-runtime gef-core" -o `pwd`/orbitDeps -a "$OPTIONS"
eclipse-pdebuild -f org.eclipse.datatools.doc.user \
  -d "emf-runtime gef-core" -o `pwd`/orbitDeps -a "$OPTIONS"

%install
install -d -m 755 %{buildroot}%{eclipse_dropin}
unzip -q -d %{buildroot}%{eclipse_dropin}/dtp-modelbase build/rpmBuild/org.eclipse.datatools.modelbase.feature.zip
unzip -q -d %{buildroot}%{eclipse_dropin}/dtp-connectivity build/rpmBuild/org.eclipse.datatools.connectivity.feature.zip
unzip -q -d %{buildroot}%{eclipse_dropin}/dtp-sqldevtools build/rpmBuild/org.eclipse.datatools.sqldevtools.feature.zip
unzip -q -d %{buildroot}%{eclipse_dropin}/dtp-enablement build/rpmBuild/org.eclipse.datatools.enablement.feature.zip
unzip -d %{buildroot}%{eclipse_dropin}/dtp-doc build/rpmBuild/org.eclipse.datatools.doc.user.zip

# use system bundles
pushd %{buildroot}%{eclipse_dropin}/dtp-enablement/eclipse/plugins
rm org.apache.xerces_*.jar
rm org.apache.xml.serializer_*.jar
ln -s ../../../../../java/xalan-j2-serializer.jar org.apache.xml.serializer_2.7.1.jar
rm org.apache.xml.resolver_*.jar
ln -s ../../../../../java/xml-commons-resolver.jar org.apache.xml.resolver_1.2.0.jar
rm javax.wsdl_*.jar
ln -s ../../../../../java/wsdl4j.jar javax.wsdl_1.5.1.jar
popd
pushd %{buildroot}%{eclipse_dropin}/dtp-sqldevtools/eclipse/plugins
rm net.sourceforge.lpg.lpgjavaruntime_*.jar
ln -s ../../../../../java/lpgjavaruntime.jar .
ln -s ../../../../../java/lucene/lucene-core.jar .
ln -s ../../../../../java/lucene/lucene-queryparser.jar .
ln -s ../../../../../java/lucene/lucene-analyzers-common.jar .
popd

%files
%{eclipse_dropin}/dtp-modelbase
%{eclipse_dropin}/dtp-connectivity
%{eclipse_dropin}/dtp-sqldevtools
%{eclipse_dropin}/dtp-enablement
%{eclipse_dropin}/dtp-doc
%doc org.eclipse.datatools.build-%{tag}/features/org.eclipse.datatools.sdk-all.feature/rootfiles/*

%changelog
* Thu Jan 15 2015 Alexander Kurtakov <akurtako@redhat.com> 1.12.0-3
- Adapt pde-build call to changed gef path.

* Wed Dec 3 2014 Alexander Kurtakov <akurtako@redhat.com> 1.12.0-2
- Fix build after eclipse-emf-runtime split.
- Modernize package a bit.

* Wed Aug 13 2014 Mat Booth <mat.booth@redhat.com> - 1.12.0-1
- Update to upstream Luna release

* Fri Jun 20 2014 Gerard Ryan <galileo@fedoraproject.org> - 1.11.2-5
- Add feature org.eclipse.datatools.doc.user

* Sat Jun 07 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.11.2-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Tue Mar 18 2014 Mat Booth <fedora@matbooth.co.uk> - 1.11.2-3
- Accomodate new Lucene sub-packages.

* Tue Mar 18 2014 Mat Booth <fedora@matbooth.co.uk> - 1.11.2-2
- Port to Lucene 4.

* Mon Mar 17 2014 Mat Booth <fedora@matbooth.co.uk> - 1.11.2-1
- Update to latest upstream, Kepler SR2.
- Drop requires on java, rhbz #1068036

* Tue Oct 1 2013 Krzysztof Daniel <kdaniel@redhat.com> 1.11.1-1
- Update to Kepler SR1.

* Sat Aug 03 2013 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.11.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_20_Mass_Rebuild

* Wed Jun 19 2013 Krzysztof Daniel <kdaniel@redhat.com> 1.11.0-1
- Update to Kepler release.

* Tue Feb 26 2013 Krzysztof Daniel <kdaniel@redhat.com> 1.10.2-1
- Update to latest upstream.

* Thu Feb 21 2013 Alexander Kurtakov <akurtako@redhat.com> 1.10.1-4
- Remove leftovers from old rpm.
- Fix too strict lucene.core scriptlet.
